Program Validate_time;
{ Asks the user to enter a formatted time until they get it right }
Uses Crt;
Var
   Time: String;                   { Time entered by user }
   Hours, Minutes: Integer;        { Hour and minute values}
   Valid_punctuation, Valid_hours, { For test results }
      Valid_minutes, Valid_length,
      Valid_chars, Hours_is_number,
      Minutes_is_number: Boolean;
   Val_error: Integer;             { For Val error code }

Begin
ClrScr;

{ Read a time repeatedly until it's valid }
Repeat

   { Ask for a time }
   Write('Please enter a time (HH:MM) ');
   ReadLn(Time);

   { Check it's the right length }
   Valid_length := Length(Time) = 5;

   { Only continue if we have the correct length }
   If Valid_length Then
      Begin

      { Read the hours part }
      Val(Copy(Time, 1, 2), Hours, Val_error);      
      Hours_is_number := (Val_error = 0); { and check it's a number }

      { Check that there's a colon in the middle }
      Valid_punctuation := Time[3] = ':';

      { Read the minutes part }
      Val(Copy(Time, 4, 2), Minutes, Val_error);      
      Minutes_is_number := (Val_error = 0); { and check it's a number }

      Valid_chars := Hours_is_number and
                     Valid_punctuation and
                     Minutes_is_number;

      { Only continue if the characters are correct }
      If Valid_chars Then
         Begin

         { Hours must be in the range 0 to 23 }
         Valid_hours := ( Hours >= 0 ) and ( Hours <= 23 );

         { Minutes must be in the range 0 to 59 }
         Valid_minutes := ( Minutes >= 0 ) and ( Minutes <= 59 );

         End
      End

   Until Valid_length and Valid_chars and Valid_hours and Valid_minutes;

WriteLn('Thank you.')

End.
