Program File_cars;
{ Reads a list of car descriptions and prints the extra }
{ details of the most expensive one. Uses a File so as not }
{ to restrict the number of cars }
Uses Crt;
Type
   Car = Record               { The information for a car }
      Make_model: String;     { The make and model }
      Price, Mpg: Real        { The price and fuel consumption }
      End;
Var
   File_name: String; { Name of the file to be read from the user }
   A_car: Car;        { Temporary car record for processing }
   Cars: File Of Car; { All the car descriptions }
   Index, High_index: Integer;  { Working index and index of priciest }
   High_price: Real;  { Highest price so far }
   Response: Char;
Begin
ClrScr;

{ Get a file for storing the cars }
Write('File name for storing the descriptions? ');
ReadLn(File_name);
Assign(Cars, File_name);
Rewrite(Cars);

{ Read and store car details from the user }
WriteLn('Please enter some car details');
Repeat
   With A_car Do  { Avoid some tedious typing }
      Begin
      Write('Make and model: ');
      ReadLn(Make_model);
      Write('Price: ');
      ReadLn(Price);
      Write('Fuel consumption: ');
      ReadLn(Mpg)
      End;
   Write(Cars, A_car); { Write the temporary car to the file }
   { Check for continue }
   Write('Continue (y or n)? ');
   Response := Readkey;
   WriteLn;
   Until (Response = 'n') Or (Response = 'N');

{ Flush the details to disk }
Close(Cars);


{ Re-open the file for reading }
Reset(Cars);

{ Look for the priciest car (choose random access for illustration) }
High_index := 0;  { Assume it's the first car }
High_price := -1; { its price must be higher than this! }
For Index := 0 To FileSize(Cars) - 1 Do
   Begin
   Seek(Cars, Index); { Find the car }
   Read(Cars, A_car); { Read it to temporary }
   If A_car.Price > High_price Then { If this one's pricier }
      Begin
      High_index := Index;      { Record its index }
      High_price := A_car.price { Overwrite the highest price }
      End
   End;

{ Print the other details of the priciest one }
WriteLn;
Seek(Cars, High_index); { Find it }
Read(Cars, A_car);      { Read it }
With A_car Do { Save some more tedious typing }
   Begin
   WriteLn('The most expensive car is the ', Make_model);
   WriteLn('Which has an average fuel consumption of ', Mpg:1:2)
   End
End.
