Program Qwerty;
{ Measures letter frequency in a text file }

Uses Crt;

Type
  Letters = 'a'..'z';
  Letter_array = Array[Letters] Of LongInt; { An array for storing }
                                            { the totals for each character }

Var
   Counts: Letter_array;
   The_file_name: String;
   The_file: Text;
   C: Char; { A character from the file }
   L: Letters; { The lower case version of a letter }

{ Break the problem down into sub-programs... }

Procedure Init_letter_array(La: Letter_array);
   { Fill a letter array with zeroes }
   Var
      L: Letters;
   Begin
   For L := 'a' To 'z' Do
      Begin
      La[L] := 0
      End
   End;

Function To_lower(C: Char): Letters;
   { Returns the lower case version of C, which must be a letter }
   Begin  
   If C < 'a' Then { If it's upper case, use Ord() to adjust it }
      Begin
      To_lower := Chr(Ord(C) + Ord('a') - Ord('A'))
      End
   Else            { Otherwise, it needs no adjusting }
      Begin
      To_lower := C
      End
   End;

Function Is_letter(C: Char): Boolean;
   { True if C is a letter, False otherwise }
   Begin
   Is_letter := ((C >= 'a') And (C <= 'z')) Or ((C >= 'A') And (C <= 'Z'))
   End;

Procedure Print_frequencies(La: Letter_array);
   { Prints the frequency of each member of La }
   Var
      L: Letters;
      Total: LongInt;
      Frequency: Real;
   Begin

   { Work out the total number of letters }
   Total := 0;
   For L := 'a' To 'z' Do
      Begin
      Total := Total + La[L]
      End;

   { Print the frequencies as percentages }
   For L := 'a' To 'z' Do
      Begin
      Frequency := (La[L] / Total * 100);
      WriteLn('Frequency of ''', L, ''' is ', Frequency:1:1, '%')
      End
   End;

Begin
ClrScr;
{ Get a file from the user }
Write('File name? ');
ReadLn(The_file_name);
Assign(The_file, The_file_name);
Reset(The_file);

Init_letter_array(Counts);

{ Process each character }
While Not Eof(The_file) Do
   Begin
   While Not Eoln(The_file) Do
      Begin
      Read(The_file, C);
      If Is_letter(C) Then { If it's a letter then increment its count }
         Begin
         L := To_lower(C);
         Counts[L] := Counts[L] + 1
         End
      End;
      Readln(The_file)
   End;

Print_frequencies(Counts);

{ Release the file }
Close(The_file)

End.
