Program Real_sort;
{ Sorts an arbitrary number of numbers entered by the user }
Uses Crt;
Type
    Branch = ^Fork;
    Fork = Record
       Data: Real;
       Left_branch, Right_branch: Branch
       End;
Var
   Trunk: Branch;
   User_data: Real;

Procedure Add(Var This_branch: Branch; New_data: Real);
   { Adds new_data to the tree starting at this_branch }
   Begin
   If This_branch = nil Then  { If there's no branch }
      Begin                 
      New(This_branch);       { Grow a new branch }
      With This_branch^ Do
         Begin
         Left_branch := Nil;
         Data := New_data;    { Put our number in the new fork at the top }
         Right_branch := Nil
         End
      End
   Else                          { OTHERWISE }
      Begin
      With This_branch^ Do    { Climb to the fork at the top of this branch }
         Begin
         If Data > New_data Then { If the number here is greater than ours }
           Begin
           Add(Left_branch, New_data) { apply the rule to the left branch }
           End
         Else
           Begin                       { OTHERWISE }
           Add(Right_branch, New_data) { Apply the rule to the right branch }
           End
         End
      End
   End;

Procedure Print(This_branch: Branch);
   { Prints the tree starting at this_branch }
   { in reverse order }
   Begin
   If This_branch <> Nil Then { If there's a branch here, }
      Begin
      With This_branch^ Do    { climb to the fork at the top of the branch }
         Begin
         Print(Left_branch);  { Apply the rule to the left branch }
         WriteLn(Data:1:3);   { Write down the number at this fork }
         Print(Right_branch)  { Apply the rule to the right branch }
         End
      End
   End;

Begin
ClrScr;

Trunk := Nil;       { Initialise the tree }

{ Prompt for input }
WriteLn('Please type in some positive numbers (-1 to finish)');

ReadLn(User_data);        { Read the first number }
While User_data <> -1 Do  { While we have a number to add }
   Begin
   Add(Trunk, User_data); { Add it }
   ReadLn(User_data)      { And read another }
   End;
Print(Trunk)        { Print the tree }
End.
