Unit Quit_Sys;
{ As Dial_sys but allows users to quit rather than entering items }
Interface

Uses Crt;

Type Rec_type = Record
                   Name             : String;
                   Date_of_birth    : String;
                   Telephone_number : String;
                End;
Var
   My_file       : File of Rec_type;
   External_name : String;
   Rec_var       : Rec_type;

Procedure Dialog_box;
Procedure Rectangle(Left_Col,Top_Row,Right_Col,Btm_Row : Integer);
Procedure Create;
Procedure Open(Var Opened : Boolean);
Procedure Add;
Procedure Find;
Procedure Amend;

Implementation

Procedure Dialog_box;
Begin
   TextBackground(Blue);
   TextColor(Yellow);
   Window(23,9,56,14);
   ClrScr;
End;

Procedure Rectangle(Left_Col,Top_Row,Right_Col,Btm_Row : Integer);
Var
   I, J : Integer;
Begin
{Draw the corner piece}
  Write(' ');
  Write(Chr(201));
{Draw the top line}
   For I := (Left_Col + 2) to (Right_Col - 2) do
      Begin
      Write(Chr(205));
      End;
{Draw corner piece and move to next line}
   WriteLn(Chr(187));
{From the top to the bottom}
   For I := (Top_Row + 1) to (Btm_Row - 1) do
   Begin
{Draw the space and the lines}
     Write(' ');
     Write(Chr(186));
{Draw the spaces in the middle}
      For J := (Left_Col + 2) to (Right_Col - 2) do
         Begin
         Write(' ');
         End;
{Draw the lines and move to next line}
      WriteLn(Chr(186));
   End;
{Draw the bottom line}
  Write(' ');
  Write(Chr(200));
   For I := (Left_Col + 2) to (Right_Col - 2) do
      Begin
      Write(Chr(205));
      End;
   Write(Chr(188));
End;

Procedure Create;
Var
   Ch : Char;
Begin
   Dialog_box;
   WriteLn('Enter a file name : ');
   ReadLn(External_name);
   If External_name <> '' Then
      Begin
      Assign(My_file, External_name);
      {$I-}
      Reset(My_file);
      {$I+}
      If IOResult = 0
         Then
            Begin
               TextColor(White+blink);
               WriteLn('File already exists!');
               TextColor(White);
               Writeln('Overwrite? Reply y/n : ');
               Readln(Ch);
               If (Ch = 'y') or (Ch = 'Y')
                  Then
                     Begin
                        Rewrite(My_file);
                        Write('DONE! Press a key to continue.');
                        Readkey;
                     End;
            End
         Else
            Begin
               Rewrite(My_file);
               Write('DONE! Press a key to continue.');
               Readkey;
            End;
      End;
   TextBackground(Blue);
   TextColor(Yellow);
End;

Procedure Open(Var Opened : Boolean);
Begin
   Dialog_box;
   WriteLn('Enter a file name : ');
   ReadLn(External_name);
   If External_name <> '' Then
      Begin
      Assign(My_file, External_name);
      {$I-}
      Reset(My_file);
      {$I+}
      If IOResult <> 0
         Then
            Begin
            Opened := False;
            TextColor(White+blink);
            WriteLn('Sorry ' , External_name );
            WriteLn('doesn''t exist!');
            WriteLn('You must create it first.');
            WriteLn('Press a key to continue.');
            Readkey;
            End
         Else
            Begin
               Opened := True;
               Write('DONE! Press a key to continue.');
               Readkey;
            End;
      End;
   TextBackground(Blue);
   TextColor(Yellow);
End;

Procedure Add;
Begin
   Dialog_box;
   Seek(My_file, FileSize(My_file));
   Writeln('Enter a name:');
   ReadLn(Rec_var.Name);
   If Rec_var.Name <> '' Then
      Begin
      Writeln('Enter a date of birth:');
      ReadLn(Rec_var.Date_of_birth);
      Writeln('Enter a telephone number:');
      ReadLn(Rec_var.Telephone_number);
      Write(My_file, Rec_var);
      End;
   TextBackground(Blue);
   TextColor(Yellow);
End;

Procedure Find;
Var
   Sought_Name        : String;
   Found              : Boolean;
   Counter, Found_ind : Integer;
Begin
   Dialog_box;
   Counter := 0;
   Writeln('Enter a name to be found : ');
   ReadLn(Sought_Name);
   If Sought_name <> '' Then
      Begin
      Repeat
         Seek(My_file, Counter);
         Read(My_file, Rec_var);
         Found := (Rec_var.Name = Sought_Name);
         Counter := Counter + 1;
         If Found
            Then
               Begin
               Found_ind := Counter;
               End;
      Until Found or Eof(My_file);
      If Found
         Then
            Begin
               Seek(My_file, Found_ind - 1);
               Read(My_file, Rec_var);
               WriteLn(Rec_var.Name);
               WriteLn(Rec_var.Date_of_birth);
               WriteLn(Rec_var.Telephone_number);
               Write('Press a key to continue.');
               Readkey;
            End
         Else
            Begin
               TextColor(White+blink);
               WriteLn(Sought_Name);
               WriteLn('is not in the file');
               TextColor(White);
               Write('Press a key to continue.');
               Readkey;
            End;
      End;
   TextBackground(Blue);
   TextColor(Yellow);
End;

Procedure Amend;
Var
   Sought_Name        : String;
   Found              : Boolean;
   Counter, Found_ind : Integer;
Begin
   Dialog_box;
   Counter := 0;
   Writeln('Enter a name to be found : ');
   ReadLn(Sought_Name);
   If Sought_name <> '' Then
      Begin
      Repeat
         Seek(My_file, Counter);
         Read(My_file, Rec_var);
         Found := (Rec_var.Name = Sought_Name);
         Counter := Counter + 1;
         If Found
            Then
               Begin
               Found_ind := Counter;
               End
      Until Found or Eof(My_file);
      If Found
         Then
            Begin
               Seek(My_file, Found_ind - 1);
               Read(My_file, Rec_var);
               WriteLn('Enter new telephone number : ');
               ReadLn(Rec_var.Telephone_number);
               Seek(My_file, Found_ind - 1);
               Write(My_file, Rec_var);
               Writeln('Press a key to continue.');
               Readkey;
            End
         Else
            Begin
               TextColor(White+blink);
               WriteLn(Sought_Name);
               WriteLn('is not in the file');
               TextColor(White);
               WriteLn('Press a key to continue.');
               Readkey;
            End;
      End;
   TextBackground(Blue);
   TextColor(Yellow);
End;
End.
