Program Ex_10_2;
{ Sorts an arbitrary number of strings entered by the user }
Uses Crt;
Type
    Branch = ^Fork;
    Fork = Record
       data: String;
       left_branch, right_branch: Branch
       End;
Var
   trunk: Branch;
   str: String;

Procedure Add(Var This_branch: Branch; New_data: String);
   { Adds new_data to the tree starting at this_branch }
   Begin
   If This_branch = nil Then  { If there's no branch }
      Begin                 
      New(This_branch);       { Grow a new branch }
      With This_branch^ Do
         Begin
         Left_branch := Nil;
         Data := New_data;    { Put our letter in the new fork at the top }
         Right_branch := Nil
         End
      End
   Else                          { OTHERWISE }
      Begin
      With This_branch^ Do       { Climb to the fork at the top of this branch }
         Begin
         If Data > New_data Then { If the letter here is greater than ours }
           Begin
           Add(Left_branch, New_data) { apply the rule to the left branch }
           End
         Else
           Begin                       { OTHERWISE }
           Add(Right_branch, New_data) { Apply the rule to the right branch }
           End
         End
      End
   End;

Procedure Print(This_branch: Branch);
   { Prints the tree starting at this_branch }
   { in reverse order }
   Begin
   If This_branch <> Nil Then { If there's a branch here, }
      Begin
      With This_branch^ Do    { climb to the fork at the top of the branch }
         Begin
         Print(Left_branch);  { Apply the rule to the left branch }
         WriteLn(Data);       { Write down the letter at this fork }
         Print(Right_branch); { Apply the rule to the right branch }
         End
      End
   End;

Begin
Clrscr;

trunk := nil;       { Initialize the tree }

{ Prompt for input }
WriteLn('Please type in some strings (blank line to finish)');

ReadLn(str);        { Read the first string }
While str <> '' Do  { While we have a string to add }
   Begin
   Add(trunk, str); { Add it }
   Readln(str)      { And read another }
   End;
Print(trunk)        { Print the tree }
End.

